﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
'Custom View class 
#Event: Click
#Event: LongClick
#RaisesSynchronousEvents:Click
#RaisesSynchronousEvents:LongClick
#DesignerProperty: Key: BgColor, DisplayName: BackgroundColor, FieldType: Color, DefaultValue: 0xffffffff , Description: 组件的背景颜色.
#DesignerProperty: Key: PressedColor, DisplayName: PressedColor, FieldType: Color, DefaultValue: 0xFFBBFF00 , Description: 组件在被单击或长按时的背景颜色.
'#DesignerProperty: Key: Icon, Displayname: Icon, FieldType: Char, DefaultValue: "" , Description: 要显示的图标
#DesignerProperty: Key: IconBgColor, DisplayName: IconBackgroundColor, FieldType: Color, DefaultValue: 0xffff0000 , Description: 负责显示图标的标签的背景色.
#DesignerProperty: Key: IconColor, DisplayName: IconColor, FieldType: Color, DefaultValue: 0xffC0C0C0 , Description: 图标的颜色.
#DesignerProperty: Key: Text, Displayname: Text, FieldType: String, DefaultValue: "计时器尚未启动", Description: 下方文字
#DesignerProperty: Key: TextColor, DisplayName: TextColor, FieldType: Color, DefaultValue: 0xff000000 , Description: 下方文字的颜色.
#DesignerProperty: Key: TextBgColor, DisplayName: TextBackgroundColor, FieldType: Color, DefaultValue: 0xFFADFF2F, Description: 负责显示下方文字的标签的背景色.

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Panel
'	Private Const DefaultColorConstant As Int = -984833 'ignore
	Private mIconLabel,mTextLabel As Label
	Private mBgColor,mPressedColor As Int
	Private mIcon As Char
	Private mText,info As String
	Private mIconColor,mIconBgColor,mTextColor,mTextBgColor As Int
	Private mLeft,mTop,mWidth,mHeight As Int
	Private xui As XUI
	Private tmr1 As Timer
	Private interval As Int=500
	Private count As Int
	info="计数器尚未启动"
	
	'如何让每个自定义组件（不论是通过designer还是code）能够自动地获取一个唯一的ID，并且用户可以访问？
	Private timeDown As Long
	
	Private mTag1 As Object
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	mBgColor=Colors.Magenta
	mPressedColor=Colors.Green
	mIcon=Chr(0xF188)
	mText=info
	mIconColor=Colors.Red
	mIconBgColor=Colors.Black
	mTextBgColor=Colors.DarkGray
	mTextColor=Colors.Green
	tmr1.Initialize("tmr1",interval)
	count=0
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	'debug
	Log(Base.Parent)
	
	
	'debug
	
	
	
	
	Dim dummy As Panel=Base
 
	mBgColor=Props.Get("BgColor")
	mPressedColor=Props.Get("PressedColor")
	mText=Props.Get("Text")
	mIconColor=Props.Get("IconColor")
	mIconBgColor=Props.Get("IconBgColor")
	mTextBgColor=Props.Get("TextBgColor")
	mTextColor=Props.Get("TextColor")
	
	'[不确定下面这四行代码是否正确。目的是能够设置整个组件的尺寸和位置
	mLeft=dummy.Left
	mTop=dummy.top
	mWidth=dummy.Width
	mHeight=dummy.Height
	
	
	Dim p As Panel
	p.Initialize("mBase")
	mBase=p
	Private mParent As Panel=Base.Parent
	mParent.AddView(mBase,mLeft,mTop,mWidth,mHeight)
	
	mTag1=Base.Tag
	mBase.Tag=Me
	dummy.RemoveView

	
	InitClass
	
End Sub

Public Sub AddParent(Parent As Object,Left As Int, Top As Int,Width As Int, Height As Int)
	Private mBase As Panel
	mBase.Initialize("mbase")
	mLeft=Left
	mTop=Top
	mWidth=Width
	mHeight=Height
	Parent.As(B4XView).AddView(mBase,Left,Top,Width,Height)
	mTag1=mBase.Tag
	mBase.Tag=Me
	
	InitClass
End Sub

Private Sub InitClass
	Dim w,h As Int '内部两个标签的宽度和高度
	w=mBase.Width*2/3
	h=mBase.Height*2/5
	mIconLabel.Initialize("IconLabel")
	mTextLabel.Initialize("TextLabel")
	'面板中添加两个标签对象。标签距离面板四周有一定空隙
	mBase.AddView(mIconLabel,1/6*mBase.Width,1/10*mBase.Height,w,h)
	mBase.AddView(mTextLabel,1/6*mBase.Width,1/2*mBase.Height,w,h)
	mBase.Color=mBgColor

	mIconLabel.Typeface=Typeface.FONTAWESOME
	mIconLabel.Text=mIcon
	mIconLabel.TextSize=mIconLabel.Height/xui.scale*0.8 '系数为经验值
	mIconLabel.TextColor=mIconColor
	mIconLabel.Color=mIconBgColor
	mIconLabel.Gravity=Gravity.CENTER
	

	mTextLabel.Text=mText
	mTextLabel.TextColor=mTextColor
	mTextLabel.Color=mTextBgColor
	mTextLabel.Gravity=Gravity.CENTER
	
	


	
End Sub


Private Sub mbase_Touch (Action As Int, X As Float, Y As Float) '[收藏]

	Log(Action)
	'Dim timeDown As Long '[timeDown应该声明为全局变量，否则会因dim语句而清零。]
	
	Select Action
		Case mBase.ACTION_DOWN
			timeDown=DateTime.Now
			tmr1.Enabled=True
			count=count+1
			mTextLabel.text=count
			mBase.Color=mPressedColor '需要闪现的颜色

		Case mBase.ACTION_UP
			Dim passedTime As Long=DateTime.Now-timeDown
			mBase.Color=mBgColor
			
			If passedTime<interval Then
				
				If SubExists(mCallBack,mEventName & "_Click") Then
					CallSubDelayed(mCallBack,mEventName & "_Click")
				End If
				
			End If
			tmr1.Enabled=False
	End Select
	
End Sub

Private Sub tmr1_Tick
	If SubExists(mCallBack,mEventName & "_LongClick") Then
		CallSubDelayed(mCallBack,mEventName & "_LongClick")
	End If
	tmr1.Enabled=False
End Sub

Public Sub ResetTapCount
	count=0
	mTextLabel.Text=info
End Sub
#Region Property routines

Public Sub GetBase As Panel
	Return mBase
End Sub

Public Sub getViewColor As Int 'TapCounter组件静态时的背景色
	Return mBgColor
End Sub

Public Sub getPressedColor As Int 'TapCounter动态(闪现)时的颜色
	Return mPressedColor
End Sub

Public Sub getIconColor As Int '图标颜色
	Return mIconColor
End Sub

Public Sub getIconBackgroundColor As Int '图标背景色
	Return mIconBgColor
End Sub

Public Sub getTapCount As Int '显示的数值(文本类型)
	Return mText
End Sub

Public Sub getTapCountColor As Int '显示的数值的颜色
	Return mTextColor
End Sub

Public Sub getTapCountBgColor As Int '显示的数值的背景色
	Return mTextBgColor
End Sub

Public Sub getTag1 As Object
	Return mTag1
End Sub

'-------

Public Sub setViewColor(color As Int)
	mBgColor=color
	mBase.Color=mBgColor
End Sub

Public Sub setPressedColor(color As Int)'【代码思路：pressedColor并非任何对象的原生属性，因此需要有代码能立即改变】
	mPressedColor=color
End Sub

Public Sub setIconColor(color As Int)'[代码思路：textcolor是mIconLabel的原生属性，因此直接通过赋值就可始改变生效。]
	mIconLabel.TextColor=color
End Sub

Public Sub setIconBackgroundColor(color As Int)
	mIconLabel.Color=color
End Sub

Public Sub setTapCountColor(color As Int)
	mTextLabel.textColor=color
End Sub

public Sub setTapCountBgColor(color As Int)
	mTextLabel.Color=color
End Sub

'tag1用于用户自定义。
Public Sub setTag1(t As Object)
	mTag1=t
End Sub
#End Region

